//             TECHNOLOGICAL ARTS
//              +1(416) 963-8996 
//	    www.technologicalarts.ca

// This is a demo program Adapt9S12D and DKKI boards.
// The Adapt9S12DP512 card, DKKI board, 4x4 Matrix Keypad and 4x16 LCD are used.

//************************************************************************
// This program illustrates using the SPI Port with an LCD, using the DKKI
// on-board Shift Register 74HC595. A 4x4 matrix keypad is interfaced with port
// H. When any key is pressed its value will be displayed on line 4 of the LCD
//************************************************************************

#include <hidef.h>            /* common defines and macros */
#include <mc9s12dp512.h>      /* derivative information */
#pragma LINK_INFO DERIVATIVE "mc9s12dp512"

#include <M_Timer.h>
#include <KEYPAD.h>
#include <LCD_S.h>
#include <Delay.h>
#include <PORT.h>
#include <PLL.h>
#include <SPI.h>

int count;
unsigned char x;

void main(void) 

{					  
  PORT_Init();				              // intialise Ports
  PLL_Initialization();			        // intialise PLL
  ModulusDown_Initialization();		  // intialise Modulus Down Counter
        
  SPI_Initialisation();			        // initalise SPI Port
  Lcd_Initialization();			        // initalise LCD

  Lcd_Display();			              // display beginning  address 

  EnableInterrupts;			            // enable interrupt
  
 while(1)
  	{ 
	  
  	  	while(x!='&') 		          // any key pressed
	  	{ 
		  display_keypad(x);            // display key
		  }
  	} 
}

//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
// This is interrupt subroutine for Modulus Down Counter Interrupt
//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
#pragma CODE_SEG __NEAR_SEG NON_BANKED
interrupt void ModulusDown_ISR(void)
{
	MCFLG = 0x80;   		            // clear flag 
	
	count++;        
        	
	if (count==5)                   // set scanning rate for each row
	{
	  count=1;
	}
       	x=READ_KEYPAD(count);		  // read keypad
}
#pragma CODE_SEG DEFAULT